"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirehoseService = exports.makeFirehoseService = void 0;
/**
 * @since 1.0.0
 */
const client_firehose_1 = require("@aws-sdk/client-firehose");
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Errors_js_1 = require("./Errors.js");
const Instance = __importStar(require("./FirehoseClientInstance.js"));
const FirehoseServiceConfig = __importStar(require("./FirehoseServiceConfig.js"));
const commands = {
    CreateDeliveryStreamCommand: client_firehose_1.CreateDeliveryStreamCommand,
    DeleteDeliveryStreamCommand: client_firehose_1.DeleteDeliveryStreamCommand,
    DescribeDeliveryStreamCommand: client_firehose_1.DescribeDeliveryStreamCommand,
    ListDeliveryStreamsCommand: client_firehose_1.ListDeliveryStreamsCommand,
    ListTagsForDeliveryStreamCommand: client_firehose_1.ListTagsForDeliveryStreamCommand,
    PutRecordCommand: client_firehose_1.PutRecordCommand,
    PutRecordBatchCommand: client_firehose_1.PutRecordBatchCommand,
    StartDeliveryStreamEncryptionCommand: client_firehose_1.StartDeliveryStreamEncryptionCommand,
    StopDeliveryStreamEncryptionCommand: client_firehose_1.StopDeliveryStreamEncryptionCommand,
    TagDeliveryStreamCommand: client_firehose_1.TagDeliveryStreamCommand,
    UntagDeliveryStreamCommand: client_firehose_1.UntagDeliveryStreamCommand,
    UpdateDestinationCommand: client_firehose_1.UpdateDestinationCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
exports.makeFirehoseService = effect_1.Effect.gen(function* () {
    const client = yield* Instance.FirehoseClientInstance;
    return commons_1.Service.fromClientAndCommands(client, commands, {
        errorTags: Errors_js_1.AllServiceErrors,
        resolveClientConfig: FirehoseServiceConfig.toFirehoseClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
class FirehoseService extends effect_1.Effect.Tag("@effect-aws/client-firehose/FirehoseService")() {
    static defaultLayer = effect_1.Layer.effect(this, exports.makeFirehoseService).pipe(effect_1.Layer.provide(Instance.layer));
    static layer = (config) => effect_1.Layer.effect(this, exports.makeFirehoseService).pipe(effect_1.Layer.provide(Instance.layer), effect_1.Layer.provide(FirehoseServiceConfig.setFirehoseServiceConfig(config)));
    static baseLayer = (evaluate) => effect_1.Layer.effect(this, exports.makeFirehoseService).pipe(effect_1.Layer.provide(effect_1.Layer.effect(Instance.FirehoseClientInstance, effect_1.Effect.map(FirehoseServiceConfig.toFirehoseClientConfig, evaluate))));
}
exports.FirehoseService = FirehoseService;
//# sourceMappingURL=FirehoseService.js.map