/**
 * @since 1.0.0
 */
import type { FirehoseClientConfig } from "@aws-sdk/client-firehose";
import { Effect, Layer } from "effect";
import type { FirehoseService } from "./FirehoseService.js";
/**
 * @since 1.0.0
 * @category firehose service config
 */
export declare const withFirehoseServiceConfig: {
    (config: FirehoseService.Config): <A, E, R>(effect: Effect.Effect<A, E, R>) => Effect.Effect<A, E, R>;
    <A, E, R>(effect: Effect.Effect<A, E, R>, config: FirehoseService.Config): Effect.Effect<A, E, R>;
};
/**
 * @since 1.0.0
 * @category firehose service config
 */
export declare const setFirehoseServiceConfig: (config: FirehoseService.Config) => Layer.Layer<never, never, never>;
/**
 * @since 1.0.0
 * @category adapters
 */
export declare const toFirehoseClientConfig: Effect.Effect<FirehoseClientConfig>;
//# sourceMappingURL=FirehoseServiceConfig.d.ts.map