"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toFirehoseClientConfig = exports.setFirehoseServiceConfig = exports.withFirehoseServiceConfig = void 0;
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Function_1 = require("effect/Function");
const GlobalValue_1 = require("effect/GlobalValue");
/**
 * @since 1.0.0
 * @category firehose service config
 */
const currentFirehoseServiceConfig = (0, GlobalValue_1.globalValue)("@effect-aws/client-firehose/currentFirehoseServiceConfig", () => effect_1.FiberRef.unsafeMake({}));
/**
 * @since 1.0.0
 * @category firehose service config
 */
exports.withFirehoseServiceConfig = (0, Function_1.dual)(2, (effect, config) => effect_1.Effect.locally(effect, currentFirehoseServiceConfig, config));
/**
 * @since 1.0.0
 * @category firehose service config
 */
const setFirehoseServiceConfig = (config) => effect_1.Layer.locallyScoped(currentFirehoseServiceConfig, config);
exports.setFirehoseServiceConfig = setFirehoseServiceConfig;
/**
 * @since 1.0.0
 * @category adapters
 */
exports.toFirehoseClientConfig = effect_1.Effect.gen(function* () {
    const { logger: serviceLogger, ...config } = yield* effect_1.FiberRef.get(currentFirehoseServiceConfig);
    const logger = serviceLogger === true
        ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.defaultServiceLogger)
        : (serviceLogger ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.make(serviceLogger)) : undefined);
    return { logger, ...config };
});
//# sourceMappingURL=FirehoseServiceConfig.js.map