import type { ConcurrentModificationException, InvalidArgumentException, InvalidKMSResourceException, InvalidSourceException, LimitExceededException, ResourceInUseException, ResourceNotFoundException, ServiceUnavailableException } from "@aws-sdk/client-firehose";
import type { TaggedException } from "@effect-aws/commons";
import { SdkError as CommonSdkError } from "@effect-aws/commons";
export declare const AllServiceErrors: readonly ["ConcurrentModificationException", "InvalidArgumentException", "InvalidKMSResourceException", "InvalidSourceException", "LimitExceededException", "ResourceInUseException", "ResourceNotFoundException", "ServiceUnavailableException"];
export type ConcurrentModificationError = TaggedException<ConcurrentModificationException>;
export type InvalidArgumentError = TaggedException<InvalidArgumentException>;
export type InvalidKMSResourceError = TaggedException<InvalidKMSResourceException>;
export type InvalidSourceError = TaggedException<InvalidSourceException>;
export type LimitExceededError = TaggedException<LimitExceededException>;
export type ResourceInUseError = TaggedException<ResourceInUseException>;
export type ResourceNotFoundError = TaggedException<ResourceNotFoundException>;
export type ServiceUnavailableError = TaggedException<ServiceUnavailableException>;
export type SdkError = CommonSdkError;
export declare const SdkError: import("effect/Data").Case.Constructor<CommonSdkError, "_tag">;
//# sourceMappingURL=Errors.d.ts.map